CMAKE_MINIMUM_REQUIRED(VERSION 3.0)

INCLUDE(ExternalProject)


FUNCTION(BUILD_CATCH BUILD_DIR INSTALL_PREFIX)

  SET(CATCH_SRC ${BUILD_DIR}/src)
  SET(CATCH_BIN ${BUILD_DIR}/bin)
  SET(CATCH_INSTALL ${INSTALL_PREFIX})
  SET(CATCH_INSTALL ${INSTALL_PREFIX} PARENT_SCOPE)

  GET_DIRECTORY_PROPERTY(CURRENT_DEFS COMPILE_DEFINITIONS)

  EXTERNALPROJECT_ADD(
    Catch
    GIT_REPOSITORY https://github.com/philsquared/Catch.git
    GIT_TAG 8ebe94ca2ea1e6ae7765f65d2f3aec08c9a85ae2
    SOURCE_DIR ${CATCH_SRC}
    BINARY_DIR ${CATCH_BIN}
    CMAKE_ARGS -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=${CATCH_INSTALL} -DCMAKE_C_COMPILER=${CMAKE_C_COMPILER} -DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER} -DCMAKE_C_FLAGS_DEBUG=${CMAKE_C_FLAGS_DEBUG} -DCMAKE_CXX_FLAGS_DEBUG=${CMAKE_CXX_FLAGS_DEBUG} -DCMAKE_C_FLAGS_RELEASE=${CMAKE_C_FLAGS_RELEASE} -DCMAKE_CXX_FLAGS_RELEASE=${CMAKE_CXX_FLAGS_RELEASE}
  )

  SET(CATCH_INCLUDE_DIRS ${CATCH_INSTALL}/include PARENT_SCOPE)

  ADD_DEPENDENCIES(DEPS Catch)

ENDFUNCTION(BUILD_CATCH)
