CMAKE_MINIMUM_REQUIRED(VERSION 3.0)

INCLUDE(ExternalProject)


FUNCTION(BUILD_JSONCPP BUILD_DIR INSTALL_PREFIX)

  SET(JSONCPP_SRC ${BUILD_DIR}/src)
  SET(JSONCPP_BIN ${BUILD_DIR}/bin)
  SET(JSONCPP_INSTALL ${INSTALL_PREFIX})
  SET(JSONCPP_INSTALL ${INSTALL_PREFIX} PARENT_SCOPE)

  EXTERNALPROJECT_ADD(
    jsoncpp
    GIT_REPOSITORY https://github.com/open-source-parsers/jsoncpp.git
    GIT_TAG 8bd4f943da288d0a6c7269a4825c4400cb3b15e9
    SOURCE_DIR ${JSONCPP_SRC}
    BINARY_DIR ${JSONCPP_BIN}
    CMAKE_ARGS -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=${JSONCPP_INSTALL} -DCMAKE_C_COMPILER=${CMAKE_C_COMPILER} -DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER} -DCMAKE_C_FLAGS_DEBUG=${CMAKE_C_FLAGS_DEBUG} -DCMAKE_CXX_FLAGS_DEBUG=${CMAKE_CXX_FLAGS_DEBUG} -DCMAKE_C_FLAGS_RELEASE=${CMAKE_C_FLAGS_RELEASE} -DCMAKE_CXX_FLAGS_RELEASE=${CMAKE_CXX_FLAGS_RELEASE}
  )

  SET(JSONCPP_LIBRARIES ${JSONCPP_INSTALL}/lib/${CMAKE_FIND_LIBRARY_PREFIXES}jsoncpp${CMAKE_STATIC_LIBRARY_SUFFIX} PARENT_SCOPE)
  SET(JSONCPP_INCLUDE_DIRS ${JSONCPP_INSTALL}/include PARENT_SCOPE)

  ADD_DEPENDENCIES(DEPS jsoncpp)

ENDFUNCTION(BUILD_JSONCPP)
