//
// Created by David Seery on 21/06/15.
// --@@
// Copyright (c) 2016 University of Sussex. All rights reserved.
//
// This file is part of the CppTransport platform.
//
// CppTransport is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
//
// CppTransport is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with CppTransport.  If not, see <http://www.gnu.org/licenses/>.
//
// @license: GPL-2
// @contributor: David Seery <D.Seery@sussex.ac.uk>
// --@@
//

#ifndef CPPTRANSPORT_ADVISORY_CLASSES_MESSAGES_H
#define CPPTRANSPORT_ADVISORY_CLASSES_MESSAGES_H


#define CPPTRANSPORT_ADVISORY_EMPTY                     "NULL"

#define CPPTRANSPORT_ADVISORY_DETECTED_AT               "detected at N="
#define CPPTRANSPORT_ADVISORY_EFOLDS                    "e-folds"

#define CPPTRANSPORT_ADVISORY_SEARCHED_FROM             "searched from N="
#define CPPTRANSPORT_ADVISORY_SEARCHED_TO               "to N="

#define CPPTRANSPORT_ADVISORY_DETECT_END                "[end of inflation was detected]"
#define CPPTRANSPORT_ADVISORY_NO_DETECT_END             "[end of inflation was not detected]"

#define CPPTRANSPORT_ADVISORY_RECORDED                  "recorded"
#define CPPTRANSPORT_ADVISORY_SAMPLES                   "samples"
#define CPPTRANSPORT_ADVISORY_LAST_RECORDED             "last recorded value ln(aH) ="
#define CPPTRANSPORT_ADVISORY_AT_N                      "at N="
#define CPPTRANSPORT_ADVISORY_LARGEST_K                 "largest k-mode being searched for ln(k) ="

#define CPPTRANSPORT_ADVISORY_FOR_K_MODE                "for mode with wavenumber k ="
#define CPPTRANSPORT_ADVISORY_WITH_TEXIT                "with horizon exit time N ="
#define CPPTRANSPORT_ADVISORY_AT_TINIT                  "at initial time"
#define CPPTRANSPORT_ADVISORY_AT_TEXIT                  "at horizon exit time"
#define CPPTRANSPORT_ADVISORY_K_A2M                     "(k/a)^2 / M"

#endif // CPPTRANSPORT_ADVISORY_CLASSES_MESSAGES_H