//
// Created by David Seery on 13/05/2014.
// --@@
// Copyright (c) 2016 University of Sussex. All rights reserved.
//
// This file is part of the CppTransport platform.
//
// CppTransport is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
//
// CppTransport is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with CppTransport.  If not, see <http://www.gnu.org/licenses/>.
//
// @license: GPL-2
// @contributor: David Seery <D.Seery@sussex.ac.uk>
// --@@
//


#ifndef CPPTRANSPORT_MESSAGES_EN_WAVENUMBER_SERIES_PLOT_PRODUCT_H
#define CPPTRANSPORT_MESSAGES_EN_WAVENUMBER_SERIES_PLOT_PRODUCT_H


#define CPPTRANSPORT_PRODUCT_K_VALUE_AXIS_LABEL_NOLATEX                "wavenumber k"
#define CPPTRANSPORT_PRODUCT_K_VALUE_AXIS_LABEL_LATEX                  "wavenumber $k$"

#define CPPTRANSPORT_PRODUCT_EFOLDS_EXIT_AXIS_LABEL_NOLATEX            "e-folds from horizon exit of k*"
#define CPPTRANSPORT_PRODUCT_EFOLDS_EXIT_AXIS_LABEL_LATEX              "e-folds from horizon exit of $k_\\star$"

#define CPPTRANSPORT_PRODUCT_ALPHA_AXIS_LABEL_NOLATEX                  "alpha"
#define CPPTRANSPORT_PRODUCT_ALPHA_AXIS_LABEL_LATEX                    "$\\alpha$"

#define CPPTRANSPORT_PRODUCT_BETA_AXIS_LABEL_NOLATEX                   "beta"
#define CPPTRANSPORT_PRODUCT_BETA_AXIS_LABEL_LATEX                     "$\\beta$"

#define CPPTRANSPORT_PRODUCT_SQUEEZING_FRACTION_K1_AXIS_LABEL_NOLATEX  "k1/k_t"
#define CPPTRANSPORT_PRODUCT_SQUEEZING_FRACTION_K1_AXIS_LABEL_LATEX    "$k_1/k_t$"

#define CPPTRANSPORT_PRODUCT_SQUEEZING_FRACTION_K2_AXIS_LABEL_NOLATEX  "k2/k_t"
#define CPPTRANSPORT_PRODUCT_SQUEEZING_FRACTION_K2_AXIS_LABEL_LATEX    "$k_2/k_t$"

#define CPPTRANSPORT_PRODUCT_SQUEEZING_FRACTION_K3_AXIS_LABEL_NOLATEX  "k3/k_t"
#define CPPTRANSPORT_PRODUCT_SQUEEZING_FRACTION_K3_AXIS_LABEL_LATEX    "$k_3/k_t$"

#define CPPTRANSPORT_PRODUCT_K_VALUE_TABLE_LABEL_NOLATEX               CPPTRANSPORT_PRODUCT_K_VALUE_AXIS_LABEL_NOLATEX
#define CPPTRANSPORT_PRODUCT_EFOLDS_EXIT_TABLE_LABEL_NOLATEX           CPPTRANSPORT_PRODUCT_EFOLDS_EXIT_AXIS_LABEL_NOLATEX
#define CPPTRANSPORT_PRODUCT_ALPHA_TABLE_LABEL_NOLATEX                 CPPTRANSPORT_PRODUCT_ALPHA_AXIS_LABEL_NOLATEX
#define CPPTRANSPORT_PRODUCT_BETA_TABLE_LABEL_NOLATEX                  CPPTRANSPORT_PRODUCT_BETA_AXIS_LABEL_NOLATEX
#define CPPTRANSPORT_PRODUCT_SQUEEZING_FRACTION_K1_TABLE_LABEL_NOLATEX CPPTRANSPORT_PRODUCT_SQUEEZING_FRACTION_K1_AXIS_LABEL_NOLATEX
#define CPPTRANSPORT_PRODUCT_SQUEEZING_FRACTION_K2_TABLE_LABEL_NOLATEX CPPTRANSPORT_PRODUCT_SQUEEZING_FRACTION_K2_AXIS_LABEL_NOLATEX
#define CPPTRANSPORT_PRODUCT_SQUEEZING_FRACTION_K3_TABLE_LABEL_NOLATEX CPPTRANSPORT_PRODUCT_SQUEEZING_FRACTION_K3_AXIS_LABEL_NOLATEX


#endif // CPPTRANSPORT_MESSAGES_EN_WAVENUMBER_SERIES_PLOT_PRODUCT_H
