//
// Created by David Seery on 05/05/2014.
// --@@
// Copyright (c) 2016 University of Sussex. All rights reserved.
//
// This file is part of the CppTransport platform.
//
// CppTransport is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
//
// CppTransport is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with CppTransport.  If not, see <http://www.gnu.org/licenses/>.
//
// @license: GPL-2
// @contributor: David Seery <D.Seery@sussex.ac.uk>
// --@@
//


#ifndef CPPTRANSPORT_MESSAGES_EN_LABELS_H
#define CPPTRANSPORT_MESSAGES_EN_LABELS_H


#define CPPTRANSPORT_YES                                "yes"
#define CPPTRANSPORT_NO                                 "no"
#define CPPTRANSPORT_WITH                               "with"

#define CPPTRANSPORT_EFOLDS                             "e-folds"

#define CPPTRANSPORT_WEEK                               "w"
#define CPPTRANSPORT_DAY                                "d"
#define CPPTRANSPORT_HOUR                               "h"
#define CPPTRANSPORT_MINUTE                             "m"
#define CPPTRANSPORT_SECOND                             "s"

#define CPPTRANSPORT_GIGABYTE                           "Gb"
#define CPPTRANSPORT_MEGABYTE                           "Mb"
#define CPPTRANSPORT_KILOBYTE                           "kb"
#define CPPTRANSPORT_BYTE                               "b"

#define CPPTRANSPORT_KCONFIG_SERIAL                     "serial ="
#define CPPTRANSPORT_KCONFIG_KEQUALS                    "comoving k ="
#define CPPTRANSPORT_KCONFIG_KTEQUALS                   "comoving k_t ="
#define CPPTRANSPORT_KCONFIG_ALPHAEQUALS                "alpha ="
#define CPPTRANSPORT_KCONFIG_BETAEQUALS                 "beta ="
#define CPPTRANSPORT_KCONFIG_T_EXIT                     "t_exit ="
#define CPPTRANSPORT_KCONFIG_T_MASSLESS                 "t_massless ="

#define CPPTRANSPORT_TIME_CONFIG_SERIAL                 "serial ="
#define CPPTRANSPORT_TIME_CONFIG_TEQUALS                "t ="

#define CPPTRANSPORT_ADAPTIVE_ICS                       "Adaptive initial conditions"
#define CPPTRANSPORT_MESH_REFINEMENTS                   "Maximum number of mesh refinements"
#define CPPTRANSPORT_PARENT_TASK                        "Parent task"

#define CPPTRANSPORT_CONTENT_GROUP                       "Content group"
#define CPPTRANSPORT_CONTENT_GROUP_LOCKED                "locked"
#define CPPTRANSPORT_CONTENT_GROUP_DATA_ROOT             "Content group root directory"
#define CPPTRANSPORT_CONTENT_GROUP_REPO_ROOT             "Repository root directory"
#define CPPTRANSPORT_CONTENT_GROUP_CREATED               "Creation date"
#define CPPTRANSPORT_CONTENT_GROUP_NOTE                  "Note"
#define CPPTRANSPORT_CONTENT_GROUP_TAGS                  "tags"

#define CPPTRANSPORT_PAYLOAD_INTEGRATION_BACKEND        "Created by backend"
#define CPPTRANSPORT_PAYLOAD_INTEGRATION_DATA           "Data container"
#define CPPTRANSPORT_PAYLOAD_OUTPUT_CONTENT_PRODUCT     "Derived product"
#define CPPTRANSPORT_PAYLOAD_OUTPUT_CONTENT_PATH        "filename"
#define CPPTRANSPORT_PAYLOAD_HAS_ZETA_TWO               "Cached zeta twopf"
#define CPPTRANSPORT_PAYLOAD_HAS_ZETA_THREE             "Cached zeta threepf"
#define CPPTRANSPORT_PAYLOAD_HAS_ZETA_REDBSP            "Cached zeta reduced bispectrum"
#define CPPTRANSPORT_PAYLOAD_HAS_FNL_LOCAL              "Cached fNL_local"
#define CPPTRANSPORT_PAYLOAD_HAS_FNL_EQUI               "Cached fNL_equi"
#define CPPTRANSPORT_PAYLOAD_HAS_FNL_ORTHO              "Cached fNL_ortho"
#define CPPTRANSPORT_PAYLOAD_HAS_FNL_DBI                "Cached fNL_DBI"

#define CPPTRANSPORT_DATAPRODUCT_NAME                   "Data product"
#define CPPTRANSPORT_DATAPRODUCT_PATH                   "path to product"
#define CPPTRANSPORT_DATAPRODUCT_CREATED                "creation date"

#define CPPTRANSPORT_LATEX_PRIME_SYMBOL                 "\\prime"
#define CPPTRANSPORT_NONLATEX_PRIME_SYMBOL              "'"

#define CPPTRANSPORT_LATEX_K_SYMBOL                     "k"
#define CPPTRANSPORT_NONLATEX_K_SYMBOL                  "k"
#define CPPTRANSPORT_LATEX_T_SYMBOL                     "N"
#define CPPTRANSPORT_NONLATEX_T_SYMBOL                  "N"
#define CPPTRANSPORT_LATEX_KT_SYMBOL                    "k_t"
#define CPPTRANSPORT_NONLATEX_KT_SYMBOL                 "k_t"
#define CPPTRANSPORT_LATEX_ALPHA_SYMBOL                 "\\alpha"
#define CPPTRANSPORT_NONLATEX_ALPHA_SYMBOL              "alpha"
#define CPPTRANSPORT_LATEX_BETA_SYMBOL                  "\\beta"
#define CPPTRANSPORT_NONLATEX_BETA_SYMBOL               "beta"

#define CPPTRANSPORT_LATEX_RE_SYMBOL                    "\\mathrm{Re}\\,"
#define CPPTRANSPORT_NONLATEX_RE_SYMBOL                 "Re"
#define CPPTRANSPORT_LATEX_IM_SYMBOL                    "\\mathrm{Im}\\,"
#define CPPTRANSPORT_NONLATEX_IM_SYMBOL                 "Im"

#define CPPTRANSPORT_LATEX_ZETA_SYMBOL                  "\\zeta"
#define CPPTRANSPORT_NONLATEX_ZETA_SYMBOL               "zeta"
#define CPPTRANSPORT_LATEX_TENSOR_SYMBOL                "h"
#define CPPTRANSPORT_NONLATEX_TENSOR_SYMBOL             "h"
#define CPPTRANSPORT_LATEX_TENSOR_MOMENTUM_SYMBOL       "\\dot{h}"
#define CPPTRANSPORT_NONLATEX_TENSOR_MOMENTUM_SYMBOL    "dot(h)"
#define CPPTRANSPORT_LATEX_R_SYMBOL                     "r"
#define CPPTRANSPORT_NONLATEX_R_SYMBOL                  "r"

#define CPPTRANSPORT_LATEX_DIMENSIONLESS_PZETA          "\\mathcal{P}_{\\zeta}"
#define CPPTRANSPORT_NONLATEX_DIMENSIONLESS_PZETA       "cal(P)_zeta"
#define CPPTRANSPORT_LATEX_DIMENSIONLESS_TWOPF          "\\Delta"
#define CPPTRANSPORT_NONLATEX_DIMENSIONLESS_TWOPF       "Delta"

#define CPPTRANSPORT_LATEX_SHAPE_FACTOR                 "(k_1 k_2 k_3)^2"
#define CPPTRANSPORT_NONLATEX_SHAPE_FACTOR              "(k_1 k_2 k_3)^2"

#define CPPTRANSPORT_LATEX_REDUCED_BISPECTRUM_SYMBOL    "f_{\\mathrm{NL}}(k_1, k_2, k_3)"
#define CPPTRANSPORT_NONLATEX_REDUCED_BISPECTRUM_SYMBOL "fNL(k1, k2, k3)"

#define CPPTRANSPORT_LATEX_FNL_LOCAL_SYMBOL             "f_{\\mathrm{NL}}^{\\mathrm{local}}"
#define CPPTRANSPORT_NONLATEX_FNL_LOCAL_SYMBOL          "fNL_local"
#define CPPTRANSPORT_FNL_LOCAL                          "fNL_local"

#define CPPTRANSPORT_LATEX_FNL_EQUI_SYMBOL              "f_{\\mathrm{NL}}^{\\mathrm{equi}}"
#define CPPTRANSPORT_NONLATEX_FNL_EQUI_SYMBOL           "fNL_equi"
#define CPPTRANSPORT_FNL_EQUI                           "fNL_equi"

#define CPPTRANSPORT_LATEX_FNL_ORTHO_SYMBOL             "f_{\\mathrm{NL}}^{\\mathrm{ortho}}"
#define CPPTRANSPORT_NONLATEX_FNL_ORTHO_SYMBOL          "fNL_ortho"
#define CPPTRANSPORT_FNL_ORTHO                          "fNL_ortho"

#define CPPTRANSPORT_LATEX_FNL_DBI_SYMBOL               "f_{\\mathrm{NL}}^{\\mathrm{DBI}}"
#define CPPTRANSPORT_NONLATEX_FNL_DBI_SYMBOL            "fNL_DBI"
#define CPPTRANSPORT_FNL_DBI                            "fNL_DBI"

#define CPPTRANSPORT_LATEX_TIME_SYMBOL                  "\\mathrm{integration time}"
#define CPPTRANSPORT_NONLATEX_TIME_SYMBOL               "integration time"
#define CPPTRANSPORT_LATEX_STEPS_SYMBOL                 "\\mathrm{integration steps}"
#define CPPTRANSPORT_NONLATEX_STEPS_SYMBOL              "integration steps"

#define CPPTRANSPORT_LATEX_EPSILON_SYMBOL               "\\epsilon"
#define CPPTRANSPORT_NONLATEX_EPSILON_SYMBOL            "epsilon"
#define CPPTRANSPORT_LATEX_ETA_SYMBOL                   "\\eta"
#define CPPTRANSPORT_NONLATEX_ETA_SYMBOL                "eta"
#define CPPTRANSPORT_LATEX_HUBBLE_SYMBOL                "H"
#define CPPTRANSPORT_NONLATEX_HUBBLE_SYMBOL             "H"
#define CPPTRANSPORT_LATEX_A_HUBBLE_SYMBOL              "aH"
#define CPPTRANSPORT_NONLATEX_A_HUBBLE_SYMBOL           "aH"
#define CPPTRANSPORT_LATEX_MASS_SPECTRUM_SYMBOL         "M_i"
#define CPPTRANSPORT_NONLATEX_MASS_SPECTRUM_SYMBOL      "M_i"
#define CPPTRANSPORT_LATEX_NORM_MASS_SPECTRUM_SYMBOL    "M_i/H"
#define CPPTRANSPORT_NONLATEX_NORM_MASS_SPECTRUM_SYMBOL "M_i/H"
#define CPPTRANSPORT_MASS_SPECTRUM_SYMBOL               "m"

#define CPPTRANSPORT_LATEX_U2_SYMBOL                    "u"
#define CPPTRANSPORT_NONLATEX_U2_SYMBOL                 "u"
#define CPPTRANSPORT_LATEX_U3_SYMBOL                    "u"
#define CPPTRANSPORT_NONLATEX_U3_SYMBOL                 "u"

#define CPPTRANSPORT_LATEX_LARGEST_U2_SYMBOL            "\\mathrm{max} (u_{\\bar{\\alpha}\\beta})"
#define CPPTRANSPORT_NONLATEX_LARGEST_U2_SYMBOL         "max u_ij"
#define CPPTRANSPORT_LATEX_LARGEST_U3_SYMBOL            "\\mathrm{max} (u_{abc})"
#define CPPTRANSPORT_NONLATEX_LARGEST_U3_SYMBOL         "max u_ijk"


#endif // CPPTRANSPORT_MESSAGES_EN_LABELS_H
