//
// Created by David Seery on 05/05/2014.
// --@@
// Copyright (c) 2016 University of Sussex. All rights reserved.
//
// This file is part of the CppTransport platform.
//
// CppTransport is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
//
// CppTransport is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with CppTransport.  If not, see <http://www.gnu.org/licenses/>.
//
// @license: GPL-2
// @contributor: David Seery <D.Seery@sussex.ac.uk>
// --@@
//


#ifndef CPPTRANSPORT_MESSAGES_EN_PARAMETERS_H
#define CPPTRANSPORT_MESSAGES_EN_PARAMETERS_H


#define CPPTRANSPORT_PARAMS_NULL_SERIALIZATION_READER "Internal error: null serialization reader passed to 'parameters' object"

#define CPPTRANSPORT_ICS_MISMATCH                     "Internal error: Mismatched number of values when constructing 'initial_conditions' object"
#define CPPTRANSPORT_PARAMS_MISMATCH                  "Internal error: Mismatched number of values when constructing 'parameters' object"
#define CPPTRANSPORT_MPLANCK_NEGATIVE                 "Nonpositive value for M_Planck is not allowed"
#define CPPTRANSPORT_PARAM_DATA_MISMATCH              "Internal error: Mismatched parameter and names in 'parameters' object"

#define CPPTRANSPORT_PARAMS_TAG                       "Parameters:"
#define CPPTRANSPORT_MPLANCK_TAG                      "M_Planck = "

#define CPPTRANSPORT_PARAMS_NULL_MODEL                "Internal error: null model in 'parameters' object"


#endif // CPPTRANSPORT_MESSAGES_EN_PARAMETERS_H
