//
// Created by David Seery on 05/05/2014.
// --@@
// Copyright (c) 2016 University of Sussex. All rights reserved.
//
// This file is part of the CppTransport platform.
//
// CppTransport is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
//
// CppTransport is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with CppTransport.  If not, see <http://www.gnu.org/licenses/>.
//
// @license: GPL-2
// @contributor: David Seery <D.Seery@sussex.ac.uk>
// --@@
//


#ifndef CPPTRANSPORT_MESSAGES_EN_RANGE_H
#define CPPTRANSPORT_MESSAGES_EN_RANGE_H


#define CPPTRANSPORT_RANGE_RANGE                       "Internal error: Out of range when accessing 'range' object"

#define CPPTRANSPORT_STEPPING_RANGE_A                  "Stepping range: "
#define CPPTRANSPORT_STEPPING_RANGE_B                  " steps, spacing = "
#define CPPTRANSPORT_STEPPING_RANGE_C                  ": min = "
#define CPPTRANSPORT_STEPPING_RANGE_D                  "max = "
#define CPPTRANSPORT_STEPPING_RANGE_E                  "Range:"
#define CPPTRANSPORT_STEPPING_RANGE_LINEAR             "linear"
#define CPPTRANSPORT_STEPPING_RANGE_LOGARITHMIC_BOTTOM "logarithmic from bottom"
#define CPPTRANSPORT_STEPPING_RANGE_LOGARITHMIC_TOP    "logarithmic from top"

#define CPPTRANSPORT_AGGREGATION_RANGE_A               "Aggregation range: "
#define CPPTRANSPORT_AGGREGATION_RANGE_B               "subranges"
#define CPPTRANSPORT_AGGREGATION_RANGE_C               "Merged range:"

#define CPPTRANSPORT_RANGE_UNKNOWN_TYPE                "Internal error: unknown range type"


#endif // CPPTRANSPORT_MESSAGES_EN_RANGE_H
